#{extends 'borderNG.html' /}
#{set 'titleHead'}
&{'kontrak.rincian_hps'}
#{/set}

<ol class="breadcrumb">
    <li><a href="@{BerandaCtr.index()}">&{'kontrak.paket_tender_ppk'}</a></li>
	<li><a href="@{lelang.KontrakCtr.sppbjPpk(lelang.lls_id)}">&{'kontrak.e_kontrak'}</a></li>
	<li><a href="@{lelang.KontrakCtr.sppbjPpkDetil(lelang.lls_id, sppbj.sppbj_id)}">&{'kontrak.form_sppbj'}</a></li>
    <li class="active">&{'kontrak.rincian_harga'}</li>
</ol>
<div class="content">
    <div id="alert"></div>
    <div class="bs-callout bs-callout-info">
        &{'kontrak.bulat_bilangan'}
	</div>
    <div id="tbl-rincian" style="margin:20px;"></div>
    <div class="pull-right">
        <table id="rekap" class="table table-condensed" style="width:300px;margin-right:50px;">
            <tr>
                <th style="text-align:right">&{'kontrak.total_nilai_caps'}</th>
                <th id="total_hps" style="text-align:right"></th>
            </tr>
        </table>
    </div>
    <div class="clearfix"></div>
    #{authenticityToken /}
	#{backButton action:@lelang.KontrakCtr.sppbjPpkDetil(lelang.lls_id, sppbj.sppbj_id) /}
</div>

#{set 'css_custom' }
<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}


#{set 'custom_script'}
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="#{assets '/bootstrap/js/papaparse.min.js'/}"></script>


<script type="text/javascript" src="#{assets '/js-xlsx/jszip.js'/}"></script>
<script type="text/javascript" src="#{assets '/js-xlsx/xlsx.js'/}"></script>>

<script type="text/javascript">
	var data = ${data?.raw()};
	var interval = 2 * 60 * 1000; // 2 menit
	var total = 0;

	function replaceChar(str) {
		var strs = "";
		if (str != undefined)
			strs += str;

		return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g, "");
	}

	var language = {
		delimiters: {
			thousands: '.',
			decimal: ','
		},
		abbreviations: {
			thousand: 'rb',
			million: 'jt',
			billion: 'M',
			trillion: 'B'
		},
		ordinal: function (number) {
			var b = number % 10;
			return (~~(number % 100 / 10) ===1) ? 'th' : (b === 1) ? 'st' : (b === 2) ? 'nd' : (b === 3) ? 'rd' : 'th';
		},
		currency: {
			symbol: 'Rp.'
		}
	};

	// Node
	if (typeof module !== 'undefined' && module.exports) {
		module.exports = language;
	}

	// Browser
	if (typeof window !== 'undefined' && this.numeral && this.numeral.language) {
		this.numeral.language('id', language);
	}

	var container = document.getElementById("tbl-rincian");//$("#tbl-rincian");
	var settings = {
		rowHeaders: true,
		height: 550,
		dataSchema: {
			item: "",
			unit: "",
			vol: 1,
			unit2: "",
			vol2: 1,
			harga: 0,
			pajak: 10,
			total_harga: 0,
			keterangan: ""
		},
		data: data,
		language: 'id',
		columns: [{data: 'item', width: 200, title: 'Jenis Barang/Jasa'},
			{data: 'unit', width: 100, title: 'Satuan'},
			{data: 'vol', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol', allowInvalid: false},
			// {data: 'unit2', width: 100, title: 'Satuan 2', allowInvalid: false},
			// {data: 'vol2', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol 2', allowInvalid: false},
			{data: 'harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Harga', allowInvalid: false},
			{data: 'pajak', type: 'numeric', format: '0,0.00', width: 60, title: 'Pajak (%)', dataSchema: 10, allowInvalid: false},
			{data: 'total_harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Total', allowInvalid: false},
			{data: 'keterangan', width: 100, title: 'Keterangan'}]
	};
	var hot = new Handsontable(container, settings);
	hot.updateSettings({
		cells: function (row, col, prop) {
			var cellProperties = {};
			if (col == 0 || col == 1 || col == 2 || col == 3 || col == 4 || col == 5 || col == 6) {
				cellProperties.readOnly = true;
			}
			if (data[row] && (col == 2)) {
				var total = 0;
				var strs = "";
				if (data[row].vol <= 0)
					data[row].vol = 0;
				if (data[row].harga > 0)
					total = data[row].harga;
				if (data[row].vol > 0)
					total = total * data[row].vol;
				if (data[row].pajak > 0)
					total = total + ((total * data[row].pajak) / 100);
				else
                    data[row].pajak = 0;
				if (total >= 0) {
					data[row].total_harga = total.toFixed(2);
					}
			}
			if (data[row] && (col == 1 || col == 2 || col == 6)) {
				data[row].item = replaceChar(data[row].item);
				data[row].unit = replaceChar(data[row].unit);
				data[row].keterangan = replaceChar(data[row].keterangan);
			}
			return cellProperties;
		},
		afterChange: function (change, source) {
			summary();
		},
		afterRemoveRow: function () {
			summary();
		}
	});

	function summary() {
		var data = hot.getData();
		var total_hps = 0;
		var total = 0;
		for (i = 0; i < data.length; i++) {
			if (data[i].total_harga)
				total += parseFloat(data[i].total_harga);
		}
		if (total > 0) {
			total_hps = parseFloat(total);
		}
		$("#rekap").find("#total_hps").text(toRupiah(total_hps.toFixed(2)));
	}
	
	$("#simpan").click(function () {
		autosave();
	});
	
	function autosave() {
		var postdata = hot.getData();
		var token = $("input[name='authenticityToken']").val();
		var total = toNumber($("#rekap").find("#total_hps").text());
		$.ajax({
			url: '@{lelang.KontrakCtr.sppbjHpsSubmit(sppbj.sppbj_id)}',
			data: {"data": JSON.stringify(postdata), "total": total, "authenticityToken": token},
			type: 'POST',
			success: function (res) {
				if (res.result === 'ok')
					$('#alert').html('<div class="alert alert-success">Data berhasil tersimpan</div>');
				else if (res.result.length > 0)
					$('#alert').html('<div class="alert alert-danger">' + res.result + '</div>');
				else
					$('#alert').html('<div class="alert alert-danger">Data gagal tersimpan, mohon periksa kembali inputan Anda</div>');
			},
			error: function () {
				$('#alert').html('<div class="alert alert-danger">Data gagal tersimpan karena ada kendala jaringan/server</div>');
			}
		});
	}
	summary();
	setInterval(autosave, interval);
</script>
#{/set}